varying vec3 normal;
varying vec4 position;

void main ()
{
  vec3 n = normalize (normal);
  vec3 l = normalize (vec3 (gl_LightSource[0].position - position));
  vec4 c = gl_FrontMaterial.ambient * gl_LightSource[0].ambient;
  float h = dot (n, l);
  if (h > 0.0) {
    c += h * gl_FrontMaterial.diffuse * gl_LightSource[0].diffuse;
    c += pow (max (dot (-normalize (position.xyz), 
                        normalize (2.0 * h * n - l)), 0.0),
	     gl_FrontMaterial.shininess) 
	 * gl_FrontMaterial.specular * gl_LightSource[0].specular;
  }
  gl_FragColor = c;
}
